From befe8b6acd7c42b7d46f20f50a9e155441e67d1b Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Thu, 20 Feb 2020 18:39:57 +0800
Subject: [PATCH 055/124] ath11k: disable CE interupt before hif start

Set irq flag to IRQ_NOAUTOEN to diable CE interrupt otherwise
interrupt may come before host initialized related context. This
also fixes unbalanced interrupt enablement.

[ 1855.138949]  complete+0x41/0x50
[ 1855.138979]  ath11k_htc_rx_completion_handler+0x511/0x550 [ath11k]
[ 1855.138986]  ? _raw_spin_lock_bh+0x8c/0xee
[ 1855.139017]  ath11k_ce_per_engine_service+0x580/0x660 [ath11k]
[ 1855.139048]  ? ath11k_ce_cleanup_pipes+0x290/0x290 [ath11k]
[ 1855.139058]  ? ath11k_pci_ce_interrupt_handler+0x5f/0x70 [ath11k_pci]
[ 1855.139066]  ? ath11k_pci_read32+0x110/0x110 [ath11k_pci]
[ 1855.139076]  ath11k_pci_ce_tasklet+0x30/0x70 [ath11k_pci]
[ 1855.139084]  tasklet_action_common.isra.18+0x1d9/0x1f0
[ 1855.139093]  ? ath11k_pci_start+0x80/0x80 [ath11k_pci]
[ 1855.139099]  __do_softirq+0x126/0x3c4
[ 1855.139106]  irq_exit+0xda/0xe0
[ 1855.139111]  do_IRQ+0x78/0x130
[ 1855.139117]  common_interrupt+0xf/0xf
[ 1855.139120]  </IRQ>

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: I4016e9862a4a279db76ed3b4cd9671f8704627c4
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/pci.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 6a34e9d..6817a4d 100644
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -480,7 +480,7 @@ static int ath11k_pci_config_irq(struct ath11k_base *ab)
 
 		tasklet_init(&ce_pipe->intr_tq, ath11k_pci_ce_tasklet,
 			     (unsigned long)ce_pipe);
-
+		irq_set_status_flags(irq, IRQ_NOAUTOEN);
 		ret = request_irq(irq, ath11k_pci_ce_interrupt_handler,
 				  IRQF_SHARED, irq_name[irq_idx],
 				  ce_pipe);
-- 
2.7.4

